# TP de prise en main des machines

Bienvenue à ce TP de prise en main des machines. Si vous en êtes ici, c'est que
vous avez réussi à mettre en place l'environnement que nous allons utiliser.

## Remarque préliminaire

On notera les appuis sur les touches par [Touche]. On notera [C-x] (se lit
Control X) l'appui sur la touche [Ctrl] puis [x] sans relâcher [Ctrl] ; [M-x]
(se lit Méta X) l'appui sur la touche [Esc] suivi de l'appui sur la touche [x].
Enfin [C-y t] signifie appuyer simultanément sur la touche [Ctrl] et la touche
[y], relâcher, puis appuyer sur la touche [t]. Les commandes à entrer seront
entourées de deux ` (accent grave seul) qu'il ne faudra pas entrer.

Si vous lisez ceci, vous avez probablement déjà effectué les opérations
suivantes (ne les refaites pas si c'est le cas !) :

- Télécharger l'archive IPI_pem_secours.tgz à l'adresse 
  http://www.ensiie.fr/~guillaume.burel/cours/IPI/IPI_pem_secours.tgz

- Ouvrir un terminal (Menu Système > Terminal Mate). Dans ce terminal il y a un
  shell (interpréteur de commande en français) qui permet d'entrer des commandes
  à exécuter.

- Entrer dans le terminal
    `tar xvzf IPI_pem_secours.tgz`
    `cd IPI_pem`
    `emacs prise_en_main_secours.md`

Conseils :

- Dans le terminal, il est possible d'utiliser la flèche vers le haut [↑] pour
  remonter dans l'historique, ainsi que d'utiliser les touches gauche [←] et
  droite [→] pour se déplacer dans la commande pour la modifier. En appuyant sur
  [C-←] et [C-→], il est possible de se déplacer mot par mot.

- Pour entrer la deuxième commande, taper `cd IP` puis taper sur la touche [Tab]
  (la touche avec les deux flèches en sens opposés au dessus de la touche avec
  le cadenas). Le nom sera automatiquement complété.

- Sous Unix le copier-coller est généralement différent de ce à quoi vous êtes
  habitué. Pour copier une zone de texte, on la sélectionne en maintenant appuyé
  le bouton gauche de la souris, puis pour la recoller on clique : le bouton du
  milieu si c'est une souris à trois boutons ou les deux boutons en même temps
  s'il n'y a que deux boutons.


## Espace de travail

Votre environnement de travail sera constitué essentiellement de deux parties :
un éditeur pour écrire le code, et un terminal pour entrer des commandes, par
exemple pour compiler le code. Ici, nous utiliserons emacs comme éditeur.
Néanmoins, vous pouvez de façon tout à fait équivalente utiliser n'importe quel
éditeur (vi, VSCode, ...). Il peut être utile dans certains cas d'avoir deux
terminaux ouverts. Dans de prochains TP, vous pourrez également avoir un
navigateur web ouvert, par exemple pour lire le sujet de TP. Il est conseillé de
mettre ce navigateur sur un autre bureau (cf. cases grises en haut vers la
droite).

### Utilisation du terminal

Certaines commandes bloquent le shell du terminal ; c'est notamment le cas de la
commande emacs que nous avons lancé. Nous allons voir comment le débloquer. 

- Revenir au terminal. On peut constater qu'il n'est pas libre, puisque le
  prompt n'est pas encore revenu, la commande n'étant pas terminée.

- Pour libérer le shell, tapez [C-z] dans la fenêtre du terminal. La commande
  emacs est stoppé (c'est-à-dire figée, mais pas terminée). Le prompt revient
  dans le shell, et il est possible de lancer une autre commande, par exemple
  `date` _(Question subsidiaire : que fait cette fonction ?)_

  On noterate qu'emacs ne réagit plus si on appuie sur des touches.

- Pour remettre en route emacs et le mettre en arrière plan, afin de laisser le
  shell libre, il suffit d'entrer dans le shell la commande `bg` (pour
  _background_, arrière-plan). Il est alors à nouveau possible d'utiliser 
  emacs ; et le shell est toujours disponible.

- Pour laisser le terminal libre dès le lancement de la commande, il est
  possible d'ajouter un & à la fin de la commande pour qu'elle soit détachée
  tout de suite ; par exemple `emacs &`.

On prendra l'habitude de ne pas fermer l'éditeur ni le terminal : on ouvrira les
nouveaux fichiers dans un seul éditeur.


## Déroulement type d'un TP

Lors d'un TP de programmation impérative, vous aurez essentiellement à écrire
vos programmes dans des fichiers dont l'extension est .c, puis compiler ces
programmes afin de créer des exécutables, et enfin lancer les exécutables ainsi
créés pour les tester. Nous allons maintenant détailler ces étapes.

### Édition d'un fichier dans VSCode

Nous allons ouvrir un nouveau fichier dans emacs. Une fois celui-ci ouvert,
vous pourrez revenir à cet énoncé en tapant [C-PgDn] (Ctrl plus la touche avec
une flèche vers le bas barrée de plusieurs traits [⇟]), ou alors en utilisant
l'interface graphique.

Il est possible d'utiliser les menus pour réaliser la plupart des opérations
ci-dessous. Néanmoins, il est plus efficace d'utiliser les raccourcis clavier
qui sont donnés.

- Pour ouvrir un fichier nommé file1.c, taper [C-x C-f] puis entrer `file1.c`. 

  Le fichier file1.c contient un programme C assez simple. Il n'est pas
  nécessaire pour l'instant de comprendre comment il marche.

- Modifier le fichier pour y mettre votre nom à la place de "Username". Noter
  l'apparition de deux étoiles ** sur la barre en bas, qui indiquent que le
  contenu du buffer a été modifié depuis la dernière sauvegarde.

- Enregistrer le fichier en tapant [C-x C-s]. Noter que les étoiles
  disparaissent.


### Compilation

La compilation consiste à traduire un programme écrit dans un langage de haut
niveau (en l'occurrence du C ici) vers du code directement exécutable par la
machine. On crée donc un exécutable qu'on peut ensuite lancer en ligne de
commande. 

- Dans le terminal, taper la commande
    `gcc -Wall file1.c`

gcc est le nom du compilateur, l'option -Wall permet d'afficher des
avertissements qui peuvent renseigner sur de potentielles erreurs de
programmation. 

Si cette commande réussit, on notera l'apparition d'un nouveau fichier nommé
a.out . C'est le fichier exécutable qui a été obtenu à partir de file1.c. (Il
est possible dans le shell d'afficher la liste des fichiers dans le répertoire
courant en tapant `ls`.) Le nom a.out est le nom donné par défaut. Pour le
modifier, il faut utiliser l'option -o de gcc, suivie du nom souhaité. Par
exemple, cela donne `gcc -Wall -o exec1 file1.c`


Remarque : entre deux compilation il peut être utile d'entrer plusieurs lignes
vides pour bien distinguer à quelle entrée correspondent les messages affichés.


### Test

Pour tester l'exécutable obtenu, il suffit de le lancer en ligne de commande.
Néanmoins, il faut que le shell sache où trouver l'exécutable en question, et
normalement il ne cherche pas dans le répertoire courant. On préfixera donc le
nom de nos exécutables par ./ pour indiquer qu'ils sont dans le répertoire
courant.

- Taper `./exec1` pour lancer l'exécutable obtenu lors de la
  compilation. Constater ce qu'il effectue.



## Correction des erreurs de compilation

Il est rare d'écrire directement un programme correct. En particulier, des
erreurs de syntaxe peuvent faire que le compilateur n'arrive pas à traduire le
programme. Dans ce cas, le compilateur donne un message d'erreur dans lequel il
décrit l'erreur et indique son emplacement. On notera la différence entre les
erreurs de compilation, pour lesquels le compilateur ne sait pas comment
produire un exécutable, et les avertissements (_warning_) qui n'empêchent pas le
compilateur de continuer mais qui peuvent être le signe d'une erreur.

- Dans emacs, ouvrir le fichier file2.c .

- Ce fichier contient volontairement des erreurs. Essayer de le compiler, puis
  corriger les erreurs (une par une, en essayant de recompiler à chaque fois
  pour vérifier que l'erreur est corrigée).

- Une fois toutes les erreurs de compilation corrigées et l'exécutable produit,
  il faut encore tester le programme. Le faire en corrigeant les erreurs
  subsistantes s'il y en a. 
  
  En particulier, on testera avec un taux de change de 0.5 et une valeur à
  convertir de 100.


Conseils :

- L'erreur "implicit declaration of function" signifie en général que l'on a
  oublié d'inclure l'interface du module qui la contient. On pourra entrer dans
  le shell `man nom_de_la_fonction` pour voir de quel module il s'agit et
  rajouter le #include <nom_du_module.h> correspondant en tête de fichier.

- En cas d'utilisation d'une fonction du module math.h, il faut lier la
  librairie mathématique lors de la compilation en rajoutant l'option -lm à la
  commande gcc.
  

## Création d'une archive pour rendu de projet

Au cours des différents projets que vous aurez à réaliser, vous devrez envoyer
votre production à votre correcteur. Celle-ci contenant plusieurs fichiers (il y
aura forcément au moins un fichier pour le code source et un rapport décrivant
votre travail), il va falloir les regrouper dans un seul. Ce fichier s'appelle
une archive, et en général, pour gagner de la place, cette archive est
compressée.  Sous Unix, l'archivage se fait généralement à l'aide de la commande
tar et la compression à l'aide d'outils externes comme gzip ou bzip2. Néanmoins,
tar dispose d'options qui permettent d'appeler automatiquement ces outils
externes, donc en pratique nous utiliserons uniquement la commande tar.  Les
principales options de tar que vous avez à connaître sont :

    t : liste le contenu de l'archive
    x : extrait le contenu de l'archive
    c : crée une archive
    z : compresse/décompresse l'archive en utilisant gzip
    j : compresse/décompresse l'archive en utilisant bzip2
    v : affiche le nom des fichiers ajoutés à/extraits de l'archive
    f suivi d'un nom de fichier : utilise ce fichier comme archive 

- Créer un répertoire Rendu à l'aide de la commande suivante :
    `mkdir Rendu`
    
- Copier les deux programmes des exercices précédents dans ce répertoire : 
    `cp file1.c file2.c Rendu`

- Entrer la commande suivante pour créer une archive :
    `tar zcvf monarchive.tar.gz Rendu/`

- Lister le contenu de l'archive nouvellement créée à l'aide de la commande :
    `tar ztf monarchive.tar.gz`
    
- Créer un répertoire tmp et s'y rendre :
    `mkdir tmp`
    `cd tmp`

- Décompresser l'archive à l'aide de :
    `tar xzvf ../monarchive.tar.gz`

- Constater (à l'aide de `ls` la création d'un nouveau répertoire Rendu
  contenant file1.c et file2.c .

- Ouvrir un navigateur (par exemple firefox).

- Aller à l'URL http://exam.ensiie.fr .

- Si vous avez un compte ENSIIE, déposer votre fichier monarchive.tar.gz dans le
  dépôt prise_en_main_ipi.


## Écriture d'un programme (pour ceux qui avancent vite)

En vous inspirant de file2.c, écrire un programme qui demande une date à
l'utilisateur, ainsi qu'un nombre n, et qui calcule la date situées n jours
après la date.

Par exemple, sur l'entrée 22 2 2020 30 (30 jours après le 22 février
2020) on doit afficher 23 3 2020.


-- 
Dernière modification le 2020-09-14
